 
/************************************************************************
 *
 * Created with Falch.net DeveloperStudio
 * http://www.falch.net/
 * 
 * File : frmMain.cpp
 * 
 * Description :  
 *
 * History:
 *			Name		Date					Description
 *			----		----					-----------
 *			default	2/28/2004 1:36:24 PM		Created

 *
 ***********************************************************************/

#include <PalmOS.h>
#include "RomanRoad.hpp"
#include "RomanRoad_res.hpp" 

UInt8 GblVerseIndex;

static Boolean UpdateScreen(UInt8 x){
/*
10 = guide
1  = next
0  = previous
*/
	if (x == 10){
		if(GblVerseIndex > 8)
			GblVerseIndex = GblVerseIndex - 10;
		else
			GblVerseIndex = GblVerseIndex + 10;
		}
	else{
		if (GblVerseIndex > 8){
			//the screen is currently on advice
			GblVerseIndex = GblVerseIndex - 10;
		}
		else{
        	if(GblVerseIndex == 0){
        		//we need to test to ensure we do not 0 - 1.
        		if(x == 0)
        			GblVerseIndex = MAXSCREEN;
        		else
        			GblVerseIndex++;		
        	} //end of if
        	else{
        		if(x == 0)
        			GblVerseIndex--;
        		if(x == 1)
        			GblVerseIndex++;
        	}
		}
		//now test to ensure we wrap back around
		if (GblVerseIndex > MAXSCREEN)
			GblVerseIndex = 0;
	}//end of outer if (x != 10);

}
static Boolean SetFormText(){
		switch(GblVerseIndex){
            	case 1: SetText("Romans 1:20-21: \nFor the invisible things of him from the creation of the world are clearly seen, being understood by the things that are made, even his eternal power and Godhead; so that they are without excuse: Because that, when they knew God, they glorified him not as God, neither were thankful; but became vain in their imaginations, and their foolish heart was darkened.", TextFieldID);
            			break; 
            	case 2: SetText("Romans 3:23: \nFor all have sinned, and come short of the glory of God.", TextFieldID);
            			break;			
            	case 3: SetText("Romans 5:8: \nBut God commendeth his love toward us, in that, while we were yet sinners, Christ died for us.", TextFieldID);
            			break;		
            	case 4: SetText("Romans 6:23: \nFor the wages of sin is death; but the gift of God is eternal life through Jesus Christ our Lord.", TextFieldID);
            			break;
            	case 5: SetText("Romans 10:9-10: \nThat if thou shalt confess with thy mouth the Lord Jesus, and shalt believe in thine heart that God hath raised him from the dead, thou shalt be saved. \nFor with the heart man believeth unto righteousness; and with the mouth confession is made unto salvation.", TextFieldID);
            			break;
            	case 6: SetText("Romans 10:13 \nFor whoever calls on the name of the LORD shall be saved." , TextFieldID);
            			break;
            	case 7: SetText("Prayer\nLord I am a sinner and my sins have separated me from you. I confess all my sins and ask for your forgiveness. Please help me avoid sinning again. I believe that Jesus Christ died for my sins and was resurrected from the dead. Please come into my heart and be the Lord of my life. In Jesuss name I pray, \n       amen.",TextFieldID);
            			break;
            	case 0: SetText("        Welcome to the Roman Road \n\nWhat do you think it takes for a person to go to Heaven? I'd like to take a moment and share with you how the Bible Answers this Question \nif that is ok with you.\n\n             Please click Next to begin.\n    Click Guide for more information.",TextFieldID);
            			break;
            	case 11: SetText("Romans 1:20-21 Guide: \nGod is the Creator of everything. We must humble ourselves as we are part of his creation.", TextFieldID);
            			break; 
            	case 12: SetText("Romans 3:23 Guide: \nWe all sin and we need forgiveness.", TextFieldID);
            			break;			
            	case 13: SetText("Romans 5:8 Guide: \nGod displayed his love for us by giving his son as a way for us to be saved from our sins. \n\nSee also John 3:16.", TextFieldID);
            			break;		
            	case 14: SetText("Romans 6:23 Guide: \nWithout forgiveness of our sins, we will be eternally separated from God (death). If we accept Jesus as our Lord and Savior and repent of our sins, we will have eternal life.", TextFieldID);
            			break;
            	case 15: SetText("Romans 10:9-10 Guide: \nConfess that Jesus Chris is Lord and believe that God raised Him from the dead and you will be saved.", TextFieldID);
            			break;
            	case 16: SetText("Romans 10:13 Guide:\nAsk Got to save you and He Will. There are no rituals or formulas that are necessary.", TextFieldID);
            			break;
            	case 17: SetText("Prayer Guide: \n1. Did you ask for forgiveness?\n2. Did you invite Jesus into your heart?\n3. Now, Tell someone about your decision.\n4. Find a local Church and get involved. Make God a part of your life",TextFieldID);
            			break;
            	case 10: SetText("   Roman Road program developed by\n               Angelfish Software LLC\n\n         www.angelfishsoftware.com\n1. Click Next, Previous, or Guide to return.\n2. This program is provided at no cost. Feel free to pass it along.\n3. If you have any questions please see our website.",TextFieldID);
            			break;					
            	default : SetText("Verse Display Error. \nresetting counter.", TextFieldID);
	        			  GblVerseIndex = 0;
            			  break;
        	} //end of switch
}

static Boolean frmMain_GuideButtonID_OnSelect(EventPtr event)
{
	UpdateScreen(10); //go back or forward
	SetFormText();    //then set the text

	return true;
}

static Boolean frmMain_PreviousButtonID_OnSelect(EventPtr event)
{
	UpdateScreen(0);
	SetFormText();
	return true;
}

static Boolean frmMain_NextButtonID_OnSelect(EventPtr event)
{
	UpdateScreen(1);
	SetFormText();
	return true;
}
  
void msgbox(Char *text){ FrmCustomAlert(CustomAlertID, text, NULL, NULL);}

void DecDebugText(UInt16 x){
  MemHandle NewTextHandle;
  Char *NewText;

  if(NewTextHandle = MemHandleNew(255)){                //set aside some memory
    NewText = (Char*) MemHandleLock(NewTextHandle);
    StrIToA(NewText, x);
    MemHandleResize(NewTextHandle, StrLen(NewText)+1);
    FrmCustomAlert(CustomAlertID, NewText, NULL, NULL);
    MemHandleUnlock(NewTextHandle);
    MemHandleFree(NewTextHandle);

   }  //end of if setting memory
}

Boolean SetText(Char* X, UInt16 fieldID){
  Boolean Set = false;
  FieldType *FieldPtr;
  FormType *form = FrmGetActiveForm();
  MemHandle OldText;
  MemHandle NewText;
  Char *FieldText;

  if(NewText = MemHandleNew(1000)){                //set aside some memory
    FieldText = (Char*) MemHandleLock(NewText);
    StrCopy(FieldText, X);
    MemHandleResize(NewText, StrLen(FieldText)+1);
    MemHandleUnlock(NewText);
    FieldPtr = (FieldType*) FrmGetObjectPtr(form, FrmGetObjectIndex(form, fieldID));
    OldText = FldGetTextHandle(FieldPtr);
    FldSetTextHandle(FieldPtr, NewText);

    if(OldText !=NULL)
    	MemHandleFree(OldText);
	
	FldDrawField(FieldPtr);

    Set = true;
   }  //end of if setting memory

  return Set;
}


/*
  HideObject()
  Input  : UInt16 representing the id of the object
  Output : Hides the object
  process: calls the FrmHideObject function
*/
void HideObject(UInt16 ItemID){
    UInt16 ItemIndex;
    FormType *form = FrmGetActiveForm();

    ItemIndex = FrmGetObjectIndex(form, ItemID);
    FrmHideObject(form, ItemIndex);
}

/*
  ShowObject()
  Input  : UInt16 representing the id of the object
  Output : Shows the object
  process: calls the FrmShowObject function
*/
void ShowObject(UInt16 ItemID){
    UInt16 ItemIndex;
    FormType *form = FrmGetActiveForm();

    ItemIndex = FrmGetObjectIndex(form, ItemID);
    FrmShowObject(form, ItemIndex);
}
    



Boolean GetFieldText(Char *ReturnText, UInt16 FieldID){
	Boolean Success = true;
	FormType *form = FrmGetActiveForm();
  	FieldType *field;  	//for the text field
	Char *TempText;		//used to catch the return of the text
    MemHandle handler, TempTextHandler;
	
	
	field = (FieldType*)FrmGetObjectPtr(form, FrmGetObjectIndex(form, FieldID));
	if (FldGetTextLength(field) > 0){
    		FldCompactText(field);
   	  	handler = FldGetTextHandle(field); //set the handle
      	if (handler != NULL) {
			TempText = (Char*)MemHandleLock(handler);
			StrCopy(ReturnText, TempText);  //copy the text over.
			MemHandleUnlock(handler);	    //free the memory back up.
		}
		else{
			Success = false; //unable to get the Field Text Handle.			
		}
	}
	else{
		StrCopy(ReturnText, "0");
		Success = false;  //there was no text.
	}
	return Success;
}

/***********************************************************************
 *
 * FUNCTION:	frmMain_HandleEvent
 *
 * DESCRIPTION:	Handles a Form event
 *
 * PARAMETERS:	event	pointer to an event structure
 *					
 * RETURNED:	returns handled/not handled
 *
 * REVISION HISTORY:
 *			Name		Date					Description
 *			----		----					-----------
 *			default	2/28/2004 1:36:24 PM		Created

 * 
 ***********************************************************************/
/*
Romans 1:20-21: For the invisible things of him from the creation of the world are clearly seen, being understood by the things that are made, even his eternal power and Godhead; so that they are without excuse: Because that, when they knew God, they glorified him not as God, neither were thankful; but became vain in their imaginations, and their foolish heart was darkened.";

STRING ID 3001 "Romans 3:23: For the invisible things of him from the creation of the world are clearly seen, being understood by the things that are made, even his eternal power and Godhead; so that they are without excuse:\r\nFor the invisible things of him from the creation of the world are clearly seen, being understood by the things that are made, even his eternal power and Godhead; so that they are without excuse: Because that, when they knew God, they glorified him not as God, neither were thankful; but became vain in their imaginations, and their foolish heart was darkened."
STRING ID 3002 "Romans 5:8: For all have sinned, and come short of the glory of God;"
STRING ID 3003 "Romans 6:23: But God commendeth his love toward us, in that, while we were yet sinners, Christ died for us."
STRING ID 3004 "Romans 10:9-10: That if thou shalt confess with thy mouth the Lord Jesus, and shalt believe in thine heart that God hath raised him from the dead, thou shalt be saved. For with the heart man believeth unto righteousness; and with the mouth confession is made unto salvation."
STRING ID 3005 "Romans 11:36: For of him, and through him, and to him, are all things: to whom be glory for ever. Amen."

*/

Boolean frmMain_HandleEvent(EventPtr event)
{
	FormPtr form;
	Boolean handled = false;

	switch (event->eType)
	{
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				// GuideButtonID receives an event
				case GuideButtonID:
					handled = frmMain_GuideButtonID_OnSelect(event);
					break;
				// TextFieldID receives an event
				case PreviousButtonID:
					handled = frmMain_PreviousButtonID_OnSelect(event);
					break;
				// NextButtonID receives an event
				case NextButtonID:
					handled = frmMain_NextButtonID_OnSelect(event);
					break;
			}
			break;
		case frmOpenEvent:
			// Repaint form on open
			form = FrmGetActiveForm();
			FrmDrawForm(form);
			GblVerseIndex = 0;
			SetFormText();
			handled = true;
			break;
		default:
			break;
	}

	return handled;
}
